package compbio.data.sequence;

import java.util.EnumMap;
import java.util.List;
import java.util.Map;

import compbio.util.annotation.NotThreadSafe;

/**
 * TODO complete
 * 
 * @author pvtroshin
 * 
 * @param <T>
 *            enum type
 */
@NotThreadSafe
public class MultiAnnotatedSequence<T extends Enum<T>> {

	private final Map<T, List<Float>> annotations;

	public MultiAnnotatedSequence(Class<T> enumeration) {
		this.annotations = new EnumMap<T, List<Float>>(enumeration);
	}

	public void addAnnotation(T type, List<Float> annotation) {
		assert type != null : "Type is expected";
		assert annotation != null : "Not empty value is expected!";
		if (!annotations.isEmpty()) {
			assert annotations.values().iterator().next().size() == annotation
					.size() : "Annotations must contain the same number of elements!";
		}
		this.annotations.put(type, annotation);
	}

	public Map<T, List<Float>> getAnnotations() {
		return new EnumMap<T, List<Float>>(this.annotations);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((annotations == null) ? 0 : annotations.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		MultiAnnotatedSequence other = (MultiAnnotatedSequence) obj;
		if (annotations == null) {
			if (other.annotations != null)
				return false;
		} else if (!annotations.equals(other.annotations))
			return false;
		return true;
	}

	@Override
	public String toString() {
		String value = "";
		for (Map.Entry<T, List<Float>> annt : annotations.entrySet()) {
			value += annt.getKey() + " ";
			value += annt.getValue() + "\n";
		}
		return value;
	}

	public JalviewAnnotation toJalviewAnnotation() {
		// TODO Auto-generated method stub
		return null;
	}
}
